<?
/**
 * login - controller
 * Sköter in och utloggning, hantering av glömda lösenord och registrering
 * $_POST['a'] = action från POST-form, föredrar att hämta från $_POST när man ändrar data
 */

//****** login ******
if($_POST['a']=='login') {
	// Skapar ett user-objekt utifrån login data
	$user = new model_user($db);
	$where = "Email = '" . $_POST['Login'] . "' AND Password = SHA1('" . $_POST['Password'] . "')";
	if (!$row = $user->GetRow($where)) {
		$session->AddError('Du har angett fel login och/eller lösenord!!');
		header ('location: ' . INDEX . '?c=' . $_GET['c'] . '&a=' . $_GET['a']);
		exit();
	}
	// Nu har vi en OK inloggning!
	// Sätter alla session variabler och laddar om sidan
	$session->Set($row['UserID'], 'UserID');
	$session->Set($row['Admin'], 'Admin');
	$session->Set($row['FirstName'] . ' ' . $row['LastName'],'Name');
	$session->AddSuccess('Welcome - you have successfully logged in!');
	header ('location: ' . INDEX);
	exit();
}

//****** logout ******
if($_POST['a']=='logout') {
	$session->Delete('UserID');
	$session->AddSuccess('You have been successfully logged out!');
	header ('location: ' . INDEX);
	exit();
}

//****** register ******
if ($_POST['a'] == 'register') {
	$check_ok=true;
	// kollar igenom de krav som skall uppfyllas.
	if (!filter_var($_POST['EMail'], FILTER_VALIDATE_EMAIL)) {
		$session->AddError('No valid Email');
		$check_ok=false;
	}
	if($_POST['FirstName']==''){
		$session->AddError('No valid FirstName');
		$check_ok=false;
	}
	if($_POST['LastName']==''){
		$session->AddError('No valid LastName');
		$check_ok=false;
	}
	if($_POST['Password']==''){
		$session->AddError('No valid Password');
		$check_ok=false;
	}
	if($_POST['Password']!=$_POST['PasswordAgain']){
		$session->AddError('Password do not match');
		$check_ok=false;
	}

	if($check_ok){
		$data = array (
			'FirstName' => $_POST['FirstName'],
			'LastName' => $_POST['LastName'],
			'EMail' => $_POST['EMail'] ,
			'Password' => sha1($_POST['Password'])
		);
		$user = new model_user($db);
		if ($user->Insert($data)) {
			$session->AddSuccess('User ' . $_POST['FirstName'] . ' ' . $_POST['LastName'] . ' with login: '. $_POST['EMail'] .  ' created!');
			header('location:' . INDEX);
			exit;
		}
	}
}


//****** sendpassword ******
if ($_POST['a'] == 'sendpassword') {
	$check_ok=true;

	if (!filter_var($_POST['EMail'], FILTER_VALIDATE_EMAIL)) {
		$session->AddError('No valid Email');
		$check_ok=false;
	}

	if ($check_ok) {
		$user = new model_user($db);
		// Kollar om användaren finns
		if (!$row = $user->GetRow("EMail = '" . $_POST['EMail']. "'")) {
			$session->AddError('Unknown EMail!');
			$check_ok=false;
		}
	}
	// Om allt är OK Skick en länk.
	if($check_ok){
		$message ='Forgot Password?

Follow this link to change your password
http://'.$_SERVER['HTTP_HOST'].$_SERVER['SCRIPT_NAME'].'?c=login&a=setpassword&key='.sha1($row['Password'].$row['UserID']) .'


---
Mail sent from Joakims MVC-example';
		if(mail($_POST['EMail'],'Password link',$message,'From: Joakim Forsgren <jf@park.se>','-f jf@park.se')){
			$session->AddSuccess('Mail sent!');
			header('location:' . INDEX);
			exit;
		}
	}
}

//****** setpassword ******
if ($_POST['a'] == 'setpassword') {
	$check_ok=true;
	$user = new model_user($db);

	// Kollar om användaren finns
	if (!$row = $user->GetRow("SHA1(CONCAT(Password,UserID)) = '" . $_POST['key']. "'")) {
		$session->AddError('Wrong Key!');
		$check_ok=false;
	}

	if($_POST['Password']==''){
		$session->AddError('No vaild Password');
		$check_ok=false;
	}

	if($_POST['Password']!=$_POST['PasswordAgain']){
		$session->AddError('Password do not match');
		$check_ok=false;
	}
	// Om allt är OK ändra lösenord.
	if($check_ok) {
		$data['Password']=sha1($_POST['Password']);
		if($user->Update($data, "UserId = '" . $row['UserID'] . "'")) {
			$session->AddSuccess('User ' . $row['FirstName'] . ' ' . $row['LastName'] . ' widht login: '. $row['EMail'] .  ' have change password!');
			header('location:' . INDEX);
			exit;
		}
	}
}
