<?php
define('PATH','../'); // Sökvägen till själva applikationen
// alla inställnignar och några funktioner
include(PATH.'include/setup.php');

// Säkrar upp vad som kommer i $_GET['c'] c=controller och i $_GET['a'] a=action, kommer inget blir det index
(isset($_GET['c'])?str_replace('.','',$_GET['c']):$_GET['c'] = 'index');
(isset($_GET['a'])?str_replace('.','',$_GET['a']):$_GET['a'] = 'index');

// läser in rätt controller
$controller = PATH . 'controllers/' . $_GET['c'] . 'Controller.php';
if (file_exists($controller)) {
	include($controller);
} else {
	$session->AddError('No controller named:' . $_GET['c'] . 'Controller');
}

// visar HTML med rätt view
include(PATH.'views/head.php');
$session->PrintInfo();; // skriver ut fel och annan info
$view = PATH . 'views/' . $_GET['c'] . '/' . $_GET['a'] . '.php';
if (file_exists($view)) {
	include($view);
} else {
	$session->AddError('No view in ' . $_GET['c']. ' named:' . $_GET['a']);
	$session->PrintInfo();; // Man vill ju se detta fel också...
}
include(PATH.'views/foot.php');