<?php
/**
 * Model Table
 * Abstrakt basklass - måste ärvas ifrån
 * Tanken är är att modeller skall kunna ärva ifrån denna
 * @uses service_db (database object)
 * @author jf
 *
 */

abstract class model_table {
	// Variabler som måste finnas
	protected $db;
	protected $table;

	public function __construct($db) {
		// Kollar om $this->table är satt
		if (!$this -> table) {
			echo 'No table selected... <br>Give up in model_table.php (' . __FILE__ . ')';
			exit ;
		}
		$this -> db = $db;
	}

	public function Update($data, $where) {
		return $this -> db -> Update($this -> table, $data, $where);
	}

	public function Insert($data) {
		return $this -> db -> Insert($this -> table, $data);
	}

	public function Delete($where) {
		$query = "DELETE FROM `" . $this -> table . "` WHERE " . $where;
		return $this -> db -> Delete($query);
	}

	public function GetRow($where) {
		$query = "SELECT * FROM `" . $this -> table . "` WHERE " . $where . " LIMIT 1";
		return $this -> db -> GetRow($query);
	}

	public function GetAll($where = 1) {
		$query = "SELECT * FROM `" . $this -> table . "` WHERE " . $where;
		return $this -> db -> GetAll($query);
	}

	public function NumRows($where) {
		$query = "SELECT * FROM `" . $this -> table . "` WHERE " . $where;
		return $this -> db -> NumRows($query);
	}

}
